

; TSRPASS	-> Passwordprotection and you don't have to activate it!
; Example for a TSR program ( After turning on your TI92 you'll have to insert
; your password -> The best way of protection ! )
 
	include "tios.h"
	include "flib.h"
	include "mxmtsr.h"
	include "mxmlib.h"
	include "macros.h"
	xdef _main
	xdef _comment

deleteoldinput:
	lea bufferpw1(PC),a0
	lea bufferpw2(PC),a1
	move.w #10,d1
deleteoldinput_loop:
	clr.b (a0)+
	clr.b (a1)+
	dbra.w d1,deleteoldinput_loop
	rts

;
; Inputroutine from MINE.ASM
; This routine is very useful
; Only used to change the password.
;

input:
	movem.l	d0-d4/a0-a2,-(sp)
	movem.l	d0-d1/a0,-(sp)
	SetFont	d4
	movem.l	(sp)+,d0-d1/a0
	move.w  #10,d0
_iql:
	dbra.w  d0,_iql
	move.l	a6,a2
	moveq	#0,d4

	bra.s	\skip1
\loop1	jsr	flib::idle_loop
	cmp.w	#13,d0			; Enter ?
	beq.s	\enter
	cmp.w	#257,d0			; Backspace ?
	bne.s	\skip2
	tst.w	d4
	beq.s	\loop1
	subq.l	#1,a2
	subq.w	#1,d4
	bra.s	\skip1
\skip2	cmp.w	d1,d4			; Maximum number of characters read ?
	bcc.s	\loop1
	cmp.w	#255,d0			; Valid character ?
	bhi.s	\loop1
	addq.w	#1,d4
	move.b	d0,(a2)+
\skip1	move.b	#95,(a2)
	move.b	#32,1(a2)
	clr.b	2(a2)
	bsr	input_
	bra.s	\loop1

\enter	move.b	#32,(a2)
	clr.b	1(a2)
	bsr	input_
	clr.b	(a2)
	move.l	a6,a2
\loop2	move.b	(a2)+,(a0)+
	bne.s	\loop2
	movem.l	(sp)+,d0-d4/a0-a2
	rts

input_:
	movem.l	d1-d2/a0,-(sp)
	move.w	#4,-(sp)
	move.l	a6,-(sp)
	move.w	d3,-(sp)
	move.w	d2,-(sp)
	jsr	tios::DrawStrXY
	lea	10(sp),sp
	movem.l	(sp)+,d1-d2/a0
	rts

_main:
	clr.w changeflg
	jsr flib::zap_screen
	SetFont #2
	WriteStr #0,#0,#4,_comment
	move.w #20,d0
	move.w #20,d1
	move.w #4,d2
	lea menuchoose(PC),a0
	lea menutitle(PC),a1
	jsr mxmlib::menu
	cmp.w #4,d0
	bcc _exit
	cmp.w #1,d0
	beq installprotection
	cmp.w #2,d0
	beq uninstallprotection
	cmp.w #3,d0
	beq newpassword
_exit:
	rts

installprotection:
	move.w #$24,d2
	jsr mxmtsr::uninstalltsr

; The original TRAP #4 is written to Trap #12

	move.w #$24,d2
	jsr mxmtsr::getoriginalinterrupt
	move.w #$700,d0
	trap #1
	bclr.b #2,$600001
	move.l a0,$80+12*4
	bset.b #2,$600001
	trap #1
	lea tsrprogram(PC),a1
	move.w #end_tsrprogram-tsrprogram,d1
	move.w #$24,d2
	jsr mxmtsr::overwritetsr
	tst.w changeflg
	beq _main
	bra comparepassword

uninstallprotection:
	move.w #$24,d2
	jsr mxmtsr::uninstalltsr
	bra _main

newpassword:
; First get the original password
	st.w changeflg
	bra installprotection
comparepassword:
	clr.w changeflg
	move.w #'CP',d0
	trap #4
; Now the new password
	jsr flib::zap_screen
	SetFont #1
	WriteStr #0,#10,#4,query_newpw
	bsr deleteoldinput
; 10 chars
	lea bufferpw1(PC),a6
	lea bufferpw2(PC),a0
	move.w #10,d1
	move.w #1,d4
	move.w #45,d3
	move.w #1,d2
	bsr input
; Write new password into the (T)SR Program and reinstall it
	lea bufferpw1(PC),a0
	lea password(PC),a1
	move.w #10,d1
copynewpassword:
	move.b (a0)+,(a1)+
	dbra.w d1,copynewpassword
	bsr deleteoldinput
	bra installprotection

;******************************************************************************
tsrprogram:	
_protection:

; If Trap #4 is called with 'CP' in D0, then we want to change the password!
; So the TI92 won't be turned off.

	cmp.w #'CP',d0
	beq #user_wants_to_change

; We'd copied the original TRAP #4 to TRAP #12

	trap #12
	bra #startprotection
user_wants_to_change:
	clr.w d0
startprotection:
	movem.l d0-d7/a0-a6,-(a7)
	move.l #3840,-(a7)
	jsr tios::HeapAlloc
	lea 4(a7),a7
	move.w d0,d1
	tios::DEREF d1,a1
	move.l a1,a2
	move.l #LCD_MEM,a0
	move.w #959,d1
clearscreen:
	move.l (a0),(a1)+
	clr.l (a0)+
	dbra.w d1,#clearscreen
	lea title(PC),a4
	move.l #LCD_MEM,a0
	move.w #19,d4
copytitlepic:
	move.l (a4)+,(a0)+
	move.l (a4)+,(a0)+
	move.l (a4)+,(a0)+
	move.l (a4)+,(a0)+
	lea 14(a0),a0
	dbra.w d4,#copytitlepic
	lea password(PC),a3
	lea passright(PC),a4
	clr.w tios::kb_vars+$1C
wait_keypressed:
	tst.b (a3)
	beq #finished
	tst.w tios::kb_vars+$1C
	beq #wait_keypressed
	clr.w (a4)
	move.w tios::kb_vars+$1E,d3
	clr.w tios::kb_vars+$1C
	move.b (a3)+,d4
	cmp.b d3,d4
	beq #wait_keypressed
	st.w (a4)
finished:
	move.l a2,a1
	move.l #LCD_MEM,a0
	move.w #959,d1
_retour:
	move.l (a1)+,(a0)+
	dbra.w d1,-4
	move.w d0,-(a7)
	jsr tios::HeapFree
	lea 2(a7),a7
	tst.w (a4)
	beq #endtrap4
	movem.l (a7)+,d0-d7/a0-a6
	bra #tsrprogram
endtrap4:
	movem.l (a7)+,d0-d7/a0-a6
	rte

password	dc.b "fargo 2",0,0,0,0,0,0
passright	dc.w 0
title		INCBIN "TITLE.PIC"
end_tsrprogram:
;******************************************************************************


installed	dc.w 0
menutitle	dc.b "Your choice?",0
menuchoose	dc.b " Install passwordprotection   ",0,
		dc.b " Deinstall passwordprotection ",0,
		dc.b " Change password              ",0,
		dc.b " Exit [ = ESC ]               ",0
query_newpw	dc.b "Your new password?",0
changeflg	dc.w 0
bufferpw1	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0
bufferpw2	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0
_comment dc.b "TSRPassword V1.0",0
	END